<?

class browserDetector {

/*

  browserDetector()
  Source: Webmonkey Code Library
  http://www.hotwired.com/webmonkey/javascript/code_library/
  
  Original Author: Richard Blaylock (blaylock@wired.com)
  Converted from JavaScript to PHP by: Mike Piontek (mike@tenseforms.com)
  
*/
	
	function browserDetector ($ua) {
	
	// set defaults
		
		$this->browser = "Unknown";
		$this->platform = "Unknown";
		$this->version = "0";
		$this->majorver = "0";
		$this->minorver = "0";
		
	// split into stuff before parens and stuff in parens
		
		$preparens = "";
		$parenthesized = "";
	
		do {
			$uaLen = strlen($ua);
			$i = strrpos($ua, "(");
			if ($i) {
				if ($parenthesized) $parenthesized .= "; ";
				$preparens = trim(substr($ua, 0, $i));
				$parenthesized .= substr($ua, $i+1, $uaLen);
				$j = strrpos($parenthesized, ")");
				if ($j >= 0) {
					$midparens = substr($parenthesized, $j+1, strlen($parenthesized));
					$preparens .= " ".$midparens;
					$parenthesized = substr($parenthesized, 0, $j);
				}
				$ua = $preparens;
			} else $preparens = $ua;
		} while ($i);
	
	// First assume browser and version are in preparens
	// override later if we find them in the parenthesized stuff
		
		$browVer = $preparens;
		
		$tokens = split(";", $parenthesized);
		$token = "";
		  
	// Now go through parenthesized tokens
		
		for ($i=0; $i < count($tokens); $i++) {
		
			$token = trim($tokens[$i]);
	
			if ($token == "compatible") {
			
				// One might want to reset browVer to a null string
				// here, but instead, we'll assume that if we don't
				// find out otherwise, then it really is Mozilla
				// (or whatever showed up before the parens).
			
		// look for browser
		
			} else if (strpos($token, "MSIE") !== false) {
				$browVer = $token;
			} else if (strpos($token, "Opera") !== false) {
				$browVer = $token;
				  
		// look for platform
		
			} else if (strpos($token, "X11") !== false || strpos($token, "SunOS") !== false || 
				strpos($token, "Linux") !== false) {
				$this->platform = "Unix";
			} else if (strpos($token, "Win") !== false) {
				$this->platform = $token;
			} else if (strpos($token, "Mac OS X") !== false) {
				$this->platform = "Mac OS X";
			} else if (strpos($token, "Mac") !== false || strpos($token, "PPC") !== false || 
				strpos($token, "PowerPC") !== false) {
				$this->platform = "Mac";
			}
		}
	
		if (strpos($browVer, "MSIE") !== false) {
			$browVer = substr($browVer, strrpos($browVer, "MSIE"), strlen($browVer));
		} else if (strpos($browVer, "Safari") !== false) {
			$browVer = substr($browVer, strrpos($browVer, "Safari"), strlen($browVer));
		}
	  
		$leftover = "";
	
		if (substr($browVer, 0, strlen("MSIE")) == "MSIE") {
			$this->browser = "IE";
			$leftover = substr($browVer, strlen("MSIE")+1, strlen($browVer));
		} else if (substr($browVer, 0, strlen("Microsoft Internet Explorer")) == "Microsoft Internet Explorer") {
			$this->browser = "IE";
			$leftover = substr($browVer, strlen("Microsoft Internet Explorer")+1, strlen($browVer));
		} else if (substr($browVer, 0, strlen("Opera")) == "Opera") {
			$this->browser = "Opera";
			$leftover = substr($browVer, strlen("Opera")+1, strlen($browVer));
		} else if (substr($browVer, 0, strlen("Safari")) == "Safari") {
			$this->browser = "Safari";
			$leftover = substr($browVer, strlen("Safari")+1, strlen($browVer));
		} else if (substr($browVer, 0, strlen("Mozilla")) == "Mozilla") {
			$this->browser = "Netscape";
			$leftover = substr($browVer, strlen("Mozilla")+1, strlen($browVer));
		} else if (substr($browVer, 0, strlen("Lynx")) == "Lynx") {
			$this->browser = "Lynx";
			$leftover = substr($browVer, strlen("Lynx")+1, strlen($browVer));
		}
		
		$leftover = trim($leftover);
		
	// Try to find the version number in what's left
		
		if (substr_count($leftover, " ") > 0) {
			$i = strrpos($leftover, " ");
			$this->version = substr($leftover, 0, $i);
		} else $this->version = $leftover;
		
		if (substr_count($this->version, ".") > 0) {
			$j = strrpos($this->version, ".");
			$this->majorver = substr($this->version, 0, $j);
			$this->minorver = substr($this->version, $j+1, strlen($this->version));
		} else $this->majorver = $this->version;
	
	} // function browserDetector()	
	
} // class browserDetector()

?>